package com.sagacloud.cache;

import org.json.JSONArray;
import org.json.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.ArrayList;
import java.util.Hashtable;
import java.util.List;

/**
 * Created by wo on 4/26/17.
 */
public class ProPasCache {
    //存储项目id->密码
    public static Hashtable<String, byte[]> proPass = new Hashtable<>();
    //存储项目id->项目名称
    public static  Hashtable<String,String> nameMap = new Hashtable<>();
    //存储项目id列表
    public static List<String> pjList = new ArrayList<>();
    //厂商id->名称
    public static Hashtable<String,String> venderNameMap = new Hashtable<>();
    //厂商id->类型
    public static Hashtable<String,Integer> venderTypeMap = new Hashtable<>();

    private static final Logger log = LoggerFactory.getLogger(ProPasCache.class);

    public static String getPjSecret(String key){
        if(proPass.get(key) == null){
            return  null;
        }
        return new String(proPass.get(key));
    }

    public static String getPjName(String pjId){
        return nameMap.get(pjId);
    }

    public static String getVenderName(String venderId){ return venderNameMap.get(venderId); }

    public static Integer getVenderType(String venderId){ return venderTypeMap.get(venderId); }

    public static void syncProject(String restr){
        try {
            proPass.clear();
            nameMap.clear();
            pjList.clear();

            JSONObject result = new JSONObject(restr);
            JSONArray arr = result.getJSONArray("Content");
            for (int i = 0; i < arr.length(); i++) {
                JSONObject proNode = arr.getJSONObject(i);
                proPass.put(proNode.getString("id"), proNode.getString("password").getBytes());
                pjList.add(proNode.getString("id"));

                JSONObject infoNode = proNode.getJSONObject("infos");
                String pjName = "";
                if(infoNode.has("ProjLocalName")){
                    pjName = infoNode.getString("ProjLocalName");
                }
                nameMap.put(proNode.getString("id"),pjName);
            }
            log.info("Succeeded to sync project.");
        }catch (Exception e){
            log.error("Failed to sync project with "+e.getMessage());
        }
    }

    public static void syncVender(String restr){
        try{
            JSONObject json = new JSONObject(restr);
            JSONArray arr = json.getJSONArray("content");
            for(int i = 0; i < arr.length(); ++i){
                JSONObject vender = arr.getJSONObject(i);
                venderNameMap.put(vender.getString("venderId"),vender.getString("name"));
                venderTypeMap.put(vender.getString("venderId"),vender.getInt("venderType"));
            }
            log.info("Succeeded to sync vender.");
        }catch (Exception e){
            log.error("Failed to sync vender with "+e.getMessage());
        }
    }
}