package com.sagacloud.route.processors.Insurance;
/*
 * Author: Jxing
 * Create Time: 2018/7/12
 */

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.sagacloud.Exceptions.InvalidPostException;
import com.sagacloud.pojos.DPSelectPropertyResult;
import com.sagacloud.pojos.Warranty;
import com.sagacloud.utils.Const;
import com.sagacloud.utils.VendersUtil;
import org.apache.camel.Exchange;
import org.apache.camel.Processor;

import java.util.*;

public class GetPropertyCountInAllWarrantyProcessor implements Processor {
    @Override
    public void process(Exchange exchange) throws Exception {
        String jsonStr = exchange.getIn().getBody(String.class);
        DPSelectPropertyResult dpResult = JSONObject.parseObject(jsonStr, DPSelectPropertyResult.class);
        //System.out.println(jsonStr);
        if(dpResult.getResult() == null && !dpResult.getResult().equals("success"))
            throw new InvalidPostException("数据平台返回异常!");
        // 保存所有保单号
        HashMap<String, Warranty> allWarranty = new HashMap<>();
        List<Warranty> ws = (List<Warranty>) exchange.getProperty("warrantyList");
        List<Map<String, Object>> propertyList = dpResult.getContent();
        //
        for(int i = 0; i < ws.size(); ++i){
            Warranty warrnaty = ws.get(i);
            warrnaty.setPropertyCount(0);
            try {
                if(!allWarranty.containsKey(warrnaty.getInsuranceNo())) {
                    allWarranty.put(warrnaty.getInsuranceNo(), warrnaty);
                }
            }catch (Exception ignore)
            {}
        }
        if(allWarranty.size() == 0 || propertyList.size() == 0)
        {
            exchange.getOut().setBody(VendersUtil.successJsonMsg("", new JSONArray()));
            return;
        }

        for(int i = propertyList.size() - 1; i > -1; --i){
            Map<String, Object> property = propertyList.get(i);
            Map<String, Object> infos = (Map<String, Object>) property.get("infos");
            if(infos.get(Const.INSUR_ID) != null && allWarranty.containsKey(infos.get(Const.INSUR_ID).toString().trim())){
                Warranty w = allWarranty.get(infos.get(Const.INSUR_ID).toString().trim());
                w.setPropertyCount(w.getPropertyCount() + 1);
            }
        }
        exchange.getOut().setBody(VendersUtil.successJsonMsg("", (JSONArray) JSONArray.toJSON(ws)));
    }
}
