package com.sagacloud.route.processors.Insurance;
/*
 * Author: Jxing
 * Create Time: 2018/7/13
 */

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.sagacloud.Exceptions.InvalidPostException;
import com.sagacloud.pojos.DPSelectPropertyResult;
import com.sagacloud.pojos.InsurancePost;
import com.sagacloud.utils.Const;
import com.sagacloud.utils.VendersUtil;
import org.apache.camel.Exchange;
import org.apache.camel.Processor;

import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

public class GetPropertyInCertainWarrantyProcessor implements Processor {
    private static Set<String> returnInfoNames = VendersUtil.createSet("EquipLocalName", "EquipLocalId", "Brand",
            "Product", "Specification");
    @Override
    public void process(Exchange exchange) throws Exception {
        String jsonStr = exchange.getIn().getBody(String.class);
        DPSelectPropertyResult dpResult = JSONObject.parseObject(jsonStr, DPSelectPropertyResult.class);
//        System.out.println(jsonStr);
        if(dpResult.getResult() == null && !dpResult.getResult().equals("success"))
            throw new InvalidPostException("数据平台返回异常!");

        InsurancePost post = (InsurancePost) exchange.getProperty("postParam");
        List<Map<String, Object>> propertyList = dpResult.getContent();

        if(propertyList.size() == 0)
        {
            exchange.getOut().setBody(VendersUtil.successJsonMsg("", new JSONArray()));
            return;
        }
        Set<String> tmp = null;
        for(int i = propertyList.size() - 1; i > -1; --i){
            Map<String, Object> property = propertyList.get(i);
            Map<String, Object> infos = (Map<String, Object>) property.get("infos");
            if(infos.get(Const.INFO_INSURANCENUM) == null || !post.getInsuranceNo().equals(infos.get(Const.INFO_INSURANCENUM).toString())){
                propertyList.remove(i);
            }else{
                tmp = new HashSet<>();
                for(String infoName : infos.keySet()){
                    if(!returnInfoNames.contains(infoName) && !tmp.contains(infoName))
                        tmp.add(infoName);
                }
                for(String infoName : tmp)
                    infos.remove(infoName);
            }
        }
        exchange.getOut().setBody(VendersUtil.successJsonMsg("", (JSONArray) JSONArray.toJSON(propertyList)));
    }
}
