package com.sagacloud.route.processors.Insurance;
/*
 * Author: Jxing
 * Create Time: 2018/7/12
 */

import com.alibaba.fastjson.JSONObject;
import com.sagacloud.Exceptions.InvalidPostException;
import com.sagacloud.cache.ProPasCache;
import com.sagacloud.pojos.InsurancePost;
import com.sagacloud.pojos.WarrantyList;
import com.sagacloud.route.InitEnvRoute;
import com.sagacloud.utils.Const;
import org.apache.camel.Exchange;
import org.apache.camel.Processor;

public class HandleWarrantyFromVenderProcessor implements Processor {
    @Override
    public void process(Exchange exchange) throws Exception {
        String jsonStr = exchange.getIn().getBody(String.class);
        WarrantyList warrantyList = JSONObject.parseObject(jsonStr, WarrantyList.class);

        if(warrantyList.getResult().equals("failure"))
            throw new InvalidPostException(warrantyList.getResultMsg() != null && warrantyList.getResult().length() > 0?
                    String.join("", "厂商库异常:", warrantyList.getResultMsg()) : "厂商库访问出错!");
        exchange.setProperty("warrantyList", warrantyList.getWarrantyList());
        InsurancePost post = (InsurancePost) exchange.getProperty("postParam");
        exchange.getIn().setBody(JSONObject.toJSONString(post));
//
//        //exchange.getIn().setBody();
//        exchange.setProperty("postParam", post);
//        exchange.getIn().setHeader(Exchange.HTTP_URI, String.join("", InitEnvRoute.venders, "/insurance/contract/query?method=POST"));
//        exchange.getIn().setHeader(Exchange.HTTP_QUERY,String.join("", Const.HEADER_PROJECT , "=", post.getProjectId(),
//                "&", Const.HEADER_SECRET, "=", ProPasCache.getPjSecret(post.getProjectId())));
    }
}
