package com.sagacloud.route.processors.Manufacturer;


import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.sagacloud.Exceptions.InvalidPostException;
import com.sagacloud.pojos.PropertyObj;
import com.sagacloud.utils.Const;
import org.apache.camel.Exchange;
import org.apache.camel.Processor;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * Created by Xiaoyu on 2018/7/12
 */
public class GetVenderBySpecProcessor implements Processor {
    @Override
    public void process(Exchange exchange) throws Exception {
        String jsonStr = exchange.getIn().getBody(String.class);
        JSONObject json = JSONObject.parseObject(jsonStr);
        if(json.getString("Result").equalsIgnoreCase("failure")){
            throw new InvalidPostException("查询数据平台资产出错");
        }
        List<PropertyObj> propertyObjList = JSONObject.parseArray(json.getJSONArray("Content").toString(),PropertyObj.class);
        List<String> specIdList = new ArrayList<>();
        for(PropertyObj p : propertyObjList){
            Map<String,Object> infos = p.getInfos();
            if(infos.containsKey(Const.SPEC_ID)){
                specIdList.add((String) infos.get(Const.SPEC_ID));
            }
        }
        //查询型号id所对应的生产商id
        JSONObject queryJson = new JSONObject();
        queryJson.put("specificationId",specIdList);
        exchange.setProperty("property",propertyObjList);
        exchange.getIn().setBody(queryJson.toString());
        exchange.getIn().setHeader(Exchange.HTTP_URI, Const.venders+"/manufacturer/specification/query_vender?method=POST");
    }
}
